Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -846,79 +966,88 @@
 void ImGuiStyle::ScaleAllSizes(float scale_factor)
 {
-   WindowPadding = ImFloor(WindowPadding * scale_factor);
-   WindowRounding = ImFloor(WindowRounding * scale_factor);
-   WindowMinSize = ImFloor(WindowMinSize * scale_factor);
-   ChildRounding = ImFloor(ChildRounding * scale_factor);
-   PopupRounding = ImFloor(PopupRounding * scale_factor);
-   FramePadding = ImFloor(FramePadding * scale_factor);
-   FrameRounding = ImFloor(FrameRounding * scale_factor);
-   ItemSpacing = ImFloor(ItemSpacing * scale_factor);
-   ItemInnerSpacing = ImFloor(ItemInnerSpacing * scale_factor);
-   TouchExtraPadding = ImFloor(TouchExtraPadding * scale_factor);
-   IndentSpacing = ImFloor(IndentSpacing * scale_factor);
-   ColumnsMinSpacing = ImFloor(ColumnsMinSpacing * scale_factor);
-   ScrollbarSize = ImFloor(ScrollbarSize * scale_factor);
-   ScrollbarRounding = ImFloor(ScrollbarRounding * scale_factor);
-   GrabMinSize = ImFloor(GrabMinSize * scale_factor);
-   GrabRounding = ImFloor(GrabRounding * scale_factor);
-   DisplayWindowPadding = ImFloor(DisplayWindowPadding * scale_factor);
-   DisplaySafeAreaPadding = ImFloor(DisplaySafeAreaPadding * scale_factor);
-   MouseCursorScale = ImFloor(MouseCursorScale * scale_factor);
+    WindowPadding = ImFloor(WindowPadding * scale_factor);
+    WindowRounding = ImFloor(WindowRounding * scale_factor);
+    WindowMinSize = ImFloor(WindowMinSize * scale_factor);
+    ChildRounding = ImFloor(ChildRounding * scale_factor);
+    PopupRounding = ImFloor(PopupRounding * scale_factor);
+    FramePadding = ImFloor(FramePadding * scale_factor);
+    FrameRounding = ImFloor(FrameRounding * scale_factor);
+    ItemSpacing = ImFloor(ItemSpacing * scale_factor);
+    ItemInnerSpacing = ImFloor(ItemInnerSpacing * scale_factor);
+    TouchExtraPadding = ImFloor(TouchExtraPadding * scale_factor);
+    IndentSpacing = ImFloor(IndentSpacing * scale_factor);
+    ColumnsMinSpacing = ImFloor(ColumnsMinSpacing * scale_factor);
+    ScrollbarSize = ImFloor(ScrollbarSize * scale_factor);
+    ScrollbarRounding = ImFloor(ScrollbarRounding * scale_factor);
+    GrabMinSize = ImFloor(GrabMinSize * scale_factor);
+    GrabRounding = ImFloor(GrabRounding * scale_factor);
+    LogSliderDeadzone = ImFloor(LogSliderDeadzone * scale_factor);
+    TabRounding = ImFloor(TabRounding * scale_factor);
+    TabMinWidthForCloseButton = (TabMinWidthForCloseButton != FLT_MAX) ? ImFloor(TabMinWidthForCloseButton * scale_factor) : FLT_MAX;
+    DisplayWindowPadding = ImFloor(DisplayWindowPadding * scale_factor);
+    DisplaySafeAreaPadding = ImFloor(DisplaySafeAreaPadding * scale_factor);
+    MouseCursorScale = ImFloor(MouseCursorScale * scale_factor);
 }
 
 ImGuiIO::ImGuiIO()
 {
-   // Most fields are initialized with zero
-   memset(this, 0, sizeof(*this));
-
-   // Settings
-   ConfigFlags = 0x00;
-   BackendFlags = 0x00;
-   DisplaySize = ImVec2(-1.0f, -1.0f);
-   DeltaTime = 1.0f / 60.0f;
-   IniSavingRate = 5.0f;
-   IniFilename = "imgui.ini";
-   LogFilename = "imgui_log.txt";
-   MouseDoubleClickTime = 0.30f;
-   MouseDoubleClickMaxDist = 6.0f;
-   for (int i = 0; i < ImGuiKey_COUNT; i++)
-      KeyMap[i] = -1;
-   KeyRepeatDelay = 0.250f;
-   KeyRepeatRate = 0.050f;
-   UserData = NULL;
-
-   Fonts = NULL;
-   FontGlobalScale = 1.0f;
-   FontDefault = NULL;
-   FontAllowUserScaling = false;
-   DisplayFramebufferScale = ImVec2(1.0f, 1.0f);
-   DisplayVisibleMin = DisplayVisibleMax = ImVec2(0.0f, 0.0f);
-
-   // Advanced/subtle behaviors
+    // Most fields are initialized with zero
+    memset(this, 0, sizeof(*this));
+    IM_ASSERT(IM_ARRAYSIZE(ImGuiIO::MouseDown) == ImGuiMouseButton_COUNT && IM_ARRAYSIZE(ImGuiIO::MouseClicked) == ImGuiMouseButton_COUNT); // Our pre-C++11 IM_STATIC_ASSERT() macros triggers warning on modern compilers so we don't use it here.
+
+    // Settings
+    ConfigFlags = ImGuiConfigFlags_None;
+    BackendFlags = ImGuiBackendFlags_None;
+    DisplaySize = ImVec2(-1.0f, -1.0f);
+    DeltaTime = 1.0f / 60.0f;
+    IniSavingRate = 5.0f;
+    IniFilename = "imgui.ini";
+    LogFilename = "imgui_log.txt";
+    MouseDoubleClickTime = 0.30f;
+    MouseDoubleClickMaxDist = 6.0f;
+    for (int i = 0; i < ImGuiKey_COUNT; i++)
+        KeyMap[i] = -1;
+    KeyRepeatDelay = 0.275f;
+    KeyRepeatRate = 0.050f;
+    UserData = NULL;
+
+    Fonts = NULL;
+    FontGlobalScale = 1.0f;
+    FontDefault = NULL;
+    FontAllowUserScaling = false;
+    DisplayFramebufferScale = ImVec2(1.0f, 1.0f);
+
+    // Miscellaneous options
+    MouseDrawCursor = false;
 #ifdef __APPLE__
-   OptMacOSXBehaviors = true;  // Set Mac OS X style defaults based on __APPLE__ compile time flag
+    ConfigMacOSXBehaviors = true;  // Set Mac OS X style defaults based on __APPLE__ compile time flag
 #else
-   OptMacOSXBehaviors = false;
+    ConfigMacOSXBehaviors = false;
 #endif
-   OptCursorBlink = true;
-
-   // Settings (User Functions)
-   GetClipboardTextFn = GetClipboardTextFn_DefaultImpl;   // Platform dependent default implementations
-   SetClipboardTextFn = SetClipboardTextFn_DefaultImpl;
-   ClipboardUserData = NULL;
-   ImeSetInputScreenPosFn = ImeSetInputScreenPosFn_DefaultImpl;
-   ImeWindowHandle = NULL;
+    ConfigInputTextCursorBlink = true;
+    ConfigWindowsResizeFromEdges = true;
+    ConfigWindowsMoveFromTitleBarOnly = false;
+    ConfigWindowsMemoryCompactTimer = 60.0f;
+
+    // Platform Functions
+    BackendPlatformName = BackendRendererName = NULL;
+    BackendPlatformUserData = BackendRendererUserData = BackendLanguageUserData = NULL;
+    GetClipboardTextFn = GetClipboardTextFn_DefaultImpl;   // Platform dependent default implementations
+    SetClipboardTextFn = SetClipboardTextFn_DefaultImpl;
+    ClipboardUserData = NULL;
+    ImeSetInputScreenPosFn = ImeSetInputScreenPosFn_DefaultImpl;
+    ImeWindowHandle = NULL;
 
 #ifndef IMGUI_DISABLE_OBSOLETE_FUNCTIONS
-   RenderDrawListsFn = NULL;
+    RenderDrawListsFn = NULL;
 #endif
 
-   // Input (NB: we already have memset zero the entire structure)
-   MousePos = ImVec2(-FLT_MAX, -FLT_MAX);
-   MousePosPrev = ImVec2(-FLT_MAX, -FLT_MAX);
-   MouseDragThreshold = 6.0f;
-   for (int i = 0; i < IM_ARRAYSIZE(MouseDownDuration); i++) MouseDownDuration[i] = MouseDownDurationPrev[i] = -1.0f;
-   for (int i = 0; i < IM_ARRAYSIZE(KeysDownDuration); i++) KeysDownDuration[i] = KeysDownDurationPrev[i] = -1.0f;
-   for (int i = 0; i < IM_ARRAYSIZE(NavInputsDownDuration); i++) NavInputsDownDuration[i] = -1.0f;
+    // Input (NB: we already have memset zero the entire structure!)
+    MousePos = ImVec2(-FLT_MAX, -FLT_MAX);
+    MousePosPrev = ImVec2(-FLT_MAX, -FLT_MAX);
+    MouseDragThreshold = 6.0f;
+    for (int i = 0; i < IM_ARRAYSIZE(MouseDownDuration); i++) MouseDownDuration[i] = MouseDownDurationPrev[i] = -1.0f;
+    for (int i = 0; i < IM_ARRAYSIZE(KeysDownDuration); i++) KeysDownDuration[i]  = KeysDownDurationPrev[i] = -1.0f;
+    for (int i = 0; i < IM_ARRAYSIZE(NavInputsDownDuration); i++) NavInputsDownDuration[i] = -1.0f;
 }
 
